﻿Imports Infragistics.UltraChart.Shared.Styles
Imports Infragistics.UltraChart.Resources

Public Class Form1

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' Create a data table with a primary key so we can find the data later
        ' Labels are required for Scatter Chart
        Dim dt As New DataTable
        dt.Columns.Add("Label", GetType(String))
        dt.PrimaryKey = New DataColumn() {dt.Columns.Add("Cycle Number", GetType(Single))}
        dt.Columns.Add("Power Info", GetType(Integer))
        dt.Columns.Add("Date", GetType(DateTime))

        ' Add some rows
        dt.Rows.Add("A", 30.0F, 1, DateTime.Parse("06/18/2015 08:03"))
        dt.Rows.Add("B", 50.0F, 2, DateTime.Parse("06/18/2015 09:11"))
        dt.Rows.Add("C", 80.0F, 3, DateTime.Parse("06/18/2015 10:32"))

        ' Basic chart setup
        UltraChart1.ChartType = ChartType.ScatterChart
        UltraChart1.DataSource = dt
        UltraChart1.Axis.X.RangeType = AxisRangeType.Custom
        UltraChart1.Axis.X.RangeMin = 0
        UltraChart1.Axis.X.RangeMax = 100
        UltraChart1.Axis.X.Labels.Orientation = TextOrientation.Horizontal

        ' Use the custom IRenderLabel
        UltraChart1.Axis.X.Labels.ItemFormatString = "<MY_VALUE>"
        Dim labelHashTable As New Hashtable()
        labelHashTable.Add("MY_VALUE", New MyLabelRenderer(dt))
        UltraChart1.LabelHash = labelHashTable

        ' Setting the AxisLabelLayoutBehavior to None will prevent text wrapping
        ' However, it can also cause the labels to overlap if they're too close together
        ' Please use with caution
        UltraChart1.Axis.X.Labels.Layout.Behavior = AxisLabelLayoutBehaviors.None
    End Sub
End Class

Public Class MyLabelRenderer
    Implements IRenderLabel

    Private chartData As DataTable

    ' Send the data table to the constructor so we can find the data in the other columns
    Public Sub New(data As DataTable)
        chartData = data
    End Sub

    Public Overloads Function ToString(ByVal context As Hashtable) As String Implements IRenderLabel.ToString
        Dim dataValue As Double = CDbl(context("DATA_VALUE"))
        Dim row As DataRow = chartData.Rows.Find(dataValue)
        If (row IsNot Nothing) Then
            ' Find the associated date
            Dim dateTime As DateTime = row.Field(Of DateTime)("Date")
            Return String.Format("{0:0E+00}" & vbLf & "{1}", dataValue, dateTime.ToString("MM/dd/yyyy HH:mm"))
        Else
            ' Don't display anything for labels with no associated data point
            Return ""
        End If
    End Function


End Class